
//
// A virtual listview implementation by Steven E. Sipe
// First published in Dr. Dobb's Journal
//

#include "stdafx.h"
#include "vlistapp.h"
#include "DataTbl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVLDataTable

IMPLEMENT_DYNAMIC(CVLDataTable, CDaoRecordset)

CVLDataTable::CVLDataTable(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CVLDataTable)
	m_Item_Number = 0;
	m_Item_Text = _T("");
	m_nFields = 2;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}


CString CVLDataTable::GetDefaultDBName()
{
	return _T("data.mdb");
}

CString CVLDataTable::GetDefaultSQL()
{
	return _T("[Data]");
}

void CVLDataTable::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CVLDataTable)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Long(pFX, _T("[Item Number]"), m_Item_Number);
	DFX_Text(pFX, _T("[Item Text]"), m_Item_Text);
	//}}AFX_FIELD_MAP
}

int CVLDataTable::NumRecords()
{
	if(!IsEOF())
	{
		MoveLast();
		MoveFirst();
	}

	return(GetRecordCount());
}

/////////////////////////////////////////////////////////////////////////////
// CVLDataTable diagnostics

#ifdef _DEBUG
void CVLDataTable::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CVLDataTable::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG

