
// main.cpp
#include <iostream.h>
#include <pthread.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>

#include "Synchronizer.h"

static void dumpstat() {
  if(havePotentialDeadlock()) {
    cout << "see potential deadlock\n";
  } else {
    cout << "do not see potential deadlock\n";
  }
}

// These are created before main is entered, guaranteeing that
// the global monitor is built before we create new threads.
static instrumentedSynchronizer a,b,c;

static void *R1(void *) {
  cout << "R1 Thread " << CurThreadId() << " try a.acquire();\n";  
  a.acquire();
  cout << "R1 Thread " << CurThreadId() << " try b.acquire();\n";  
  b.acquire();
  sleep(2);
  cout << "R1 Thread " << CurThreadId() << " try a.release();\n"; 
  a.release();
  cout << "R1 Thread " << CurThreadId() << " try b.release();\n"; 
  b.release();
  return NULL;
}

static void *R2(void *) {
  sleep(1);
  cout << "R2 Thread " << CurThreadId() << " try b.acquire();\n";  
  b.acquire();
  cout << "R2 Thread " << CurThreadId() << " try c.acquire();\n";  
  c.acquire();
  cout << "R2 Thread " << CurThreadId() << " try c.release();\n"; 
  c.release();
  cout << "R2 Thread " << CurThreadId() << " try b.release();\n"; 
  b.release();
  return NULL;
}

static void *R3(void *) {
  sleep(1);
  cout << "R3 Thread " << CurThreadId() << " try a.acquire();\n";  
  a.acquire();
  cout << "R3 Thread " << CurThreadId() << " try c.acquire();\n";  
  c.acquire();
  cout << "R3 Thread " << CurThreadId() << " try c.release();\n"; 
  c.release();
  cout << "R3 Thread " << CurThreadId() << " try a.release();\n"; 
  a.release();
  return NULL;
}

static void *R4(void *) {
  sleep(3);
  cout << "R4 Thread " << CurThreadId() << " try c.acquire();\n";  
  c.acquire();
  cout << "R4 Thread " << CurThreadId() << " try a.acquire();\n";  
  a.acquire();
  cout << "R4 Thread " << CurThreadId() << " try c.release();\n"; 
  c.release();
  cout << "R4 Thread " << CurThreadId() << " try a.release();\n"; 
  a.release();
  return NULL;
}

int main(int argc, char *argv[]) {
  bool fail = (argc>1);
  pthread_t T1,T2,TX;
  pthread_create(&T1,NULL,R1,NULL);
  pthread_create(&T2,NULL,R2,NULL);
  if(!fail) {
    pthread_create(&TX,NULL,R3,NULL);
  } else {
    pthread_create(&TX,NULL,R4,NULL);
  }
  sleep(5); 
  dumpstat(); 
  return 0;
}
