//
// A virtual listview implementation by Steven E. Sipe
// First published in Dr. Dobb's Journal
//

#if !defined(AFX_MAINDLG_H__25322658_E9C7_11D1_939A_00600837DA75__INCLUDED_)
#define AFX_MAINDLG_H__25322658_E9C7_11D1_939A_00600837DA75__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CVLDlg dialog

#include "datatbl.h"
#include "vlist.h"

struct DATA_ITEM
{
	int nItemNumber;
	CString strItemText;
};

#define UM_INITIALIZE (WM_USER+1000)

class CVLDlg : public CDialog, public CVListData
{
// Private data
protected:
	CDaoDatabase m_Database;
	CVLDataTable m_DataTable;
	DATA_ITEM m_arrCachedData[50];
	int m_nCacheStart;
	int m_nCacheEnd;
	CBitmap m_bmSearch;

// Private methods
protected:
	void SetupDB();
	int FindPartial(LPCTSTR lpszItemText);
	virtual void OnCacheHint(int nID, int nFrom, int nTo);
	virtual int  OnFindItem(int nID, LPCTSTR lpszMatch);
	virtual void OnGetDispInfo(int nID, int iItem, int iSubItem, int mask, 
							int iImage, int state, LPTSTR pszText, 
							int cchTextMax);

// Construction
public:
	CVLDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CVLDlg)
	enum { IDD = IDD_VLIST_DIALOG };
	CButton	m_SearchButton;
	CString	m_Search;
	//}}AFX_DATA
	CVListCtrl m_List;

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVLDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CVLDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDestroy();
	afx_msg void OnSearchBtn();
	//}}AFX_MSG
	LRESULT OnInitialize(WPARAM,LPARAM);

	DECLARE_MESSAGE_MAP()
};

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINDLG_H__25322658_E9C7_11D1_939A_00600837DA75__INCLUDED_)
