//
// A virtual listview implementation by Steven E. Sipe
// First published in Dr. Dobb's Journal
//

#if !defined(AFX_LIST_H__CB4004C2_14DC_11D2_93CF_00600837DA75__INCLUDED_)
#define AFX_LIST_H__CB4004C2_14DC_11D2_93CF_00600837DA75__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// List.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CVListCtrl window

class CVListData;

class CVListCtrl : public CListCtrl
{
protected:
	CVListData *m_pDataInterface;
	int m_nID;
	COLORREF m_crFG, m_crBG, m_crSelFG, m_crSelBG, m_crBand;
	BOOL m_bBand;

// Construction
public:
	CVListCtrl();

// Attributes
public:
	void SetDataProvider(CVListData *pDataInterface) { 	m_pDataInterface = pDataInterface; }
	void SetID(int nID) { m_nID = nID; }
	void SetColors(COLORREF crFG, COLORREF crBG, COLORREF crSelFG, COLORREF crSelBG);
	void SetBand(BOOL bBand, COLORREF crBand);

// Operations
public:
	void SelectItem(int nIndex);
	void SelectItem(LPCTSTR lpszItem);
	void SetItemCount(int nCount);

	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVListCtrl)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CVListCtrl();

	// Generated message map functions
protected:
	//{{AFX_MSG(CVListCtrl)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSysColorChange();
	//}}AFX_MSG

	afx_msg void OnLVFindItem(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLVCacheHint(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnGetDispInfoList(NMHDR* pNMHDR, LRESULT* pResult);

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

// Data interface class

class CVListData
{
public:
	// Handles loading of data cache
	virtual void OnCacheHint(int nID, int nFrom, int nTo) {}

	// Handles locating matching entry
	virtual int  OnFindItem(int nID, LPCTSTR lpszMatch) { return 0; }

	// Handles providing data to display
	virtual void OnGetDispInfo(int nID, int iItem, int iSubItem, int mask, 
					int iImage, int state, LPTSTR pszText, int cchTextMax) {}
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.



#endif // !defined(AFX_LIST_H__CB4004C2_14DC_11D2_93CF_00600837DA75__INCLUDED_)
